const oracledb = require('oracledb')
const variables = require('../../configuration/variables')

class OracleConnection {

    constructor() {
    }

    getDataBaseConfig(databaseConfig) {
        let config_retorno = databaseConfig.schema.toString().toLowerCase() === variables.Database.user.toString().toLowerCase() ?
            {
                user: variables.Database.user.toLowerCase(),
                password: variables.Database.password.toLowerCase(),
                connectString: variables.Database.connectString.toLowerCase()
            }
            :
            {
                user: databaseConfig.schema.toLowerCase(),
                password: `super${databaseConfig.schema.toLowerCase()}`,
                connectString: variables.Database.connectString.toLowerCase()
            }
        return config_retorno
    }

    async getConnection(databaseConfig) {
        let connection;
        try {
            let _configuration = this.getDataBaseConfig(databaseConfig);
            connection = await oracledb.getConnection(_configuration);
            console.info(`Connect on Database: ${_configuration.connectString} as ${_configuration.user} schema.`)
        } catch (err) {
            console.error('getConnection con error ->', err);
        }
        return connection;
    }
}

module.exports = OracleConnection;
