'use strict'

const oracleConnection = require('./infra/oracleConnection')

class repositoryBase {

    constructor() {
        this._database_config = {}
        this._dataSource = new oracleConnection()
    }

    async findById(id) {
        return {'retorno': 'not implemented yet'}
    }

    async get() {
        throw `Not implemented yet...`
    }

    setDatabaseConfig(database_config) {
        this._database_config = database_config;
    }

    async getConnection() {
        let connection = await this._dataSource.getConnection(this._database_config)
        await this.setDateTimeSession(connection)
        return connection
    }

    async closeConnection(connection) {
        await connection.close()
            .catch(err => console.error(err.message))
    }

    async setDateTimeSession(connection) {
        await connection.execute(`ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS'`)
            .catch(err => console.error(err.message))
    }
}

module.exports = repositoryBase
