'use strict'

const jwt = require('jsonwebtoken')
const variables = require('../bin/configuration/variables')

module.exports = async (req, res, next) => {
    let token = req.body.token || req.query.query || req.headers['x-access-token']

    if (token) {
        try {
            let decoded = await jwt.verify(token, variables.Security.secretkey);
            req.usuarioLogado = {...decoded.user}
            next()
        } catch (error) {
            console.error('error authentication ->', error)
            res.status(401).send({errores: [{code: 500, mensaje: `Token de acesso ${token} es invalido...`}]})
            return
        }
    } else {
        res.status(401).send({
            errores: [{
                code: 500,
                mensaje: `Es necessario informar en x-access-token para este recurso`
            }]
        })
        return
    }
}
