"use strict"

require("../models/usuario-model")
const base = require('../bin/base/repository-base')
const oracledb = require('oracledb')
const Usuario = require(`../models/usuario-model`)


class usuarioRepository extends base {
    constructor() {
        super()
    }

    decript(str) {
        let reverseString = str.split("").reverse().join("");
        let stringArray = reverseString.split("")
        let result = '';

        stringArray.forEach(element => {
            result += String.fromCharCode(element.charCodeAt(0) ^ 3)
        });

        return result;
    }

    async authenticate(usuario) {
        let usuarioLogado = new Usuario;

        let connection = await this.getConnection()

        let options = {
            autoCommit: true,
            outFormat: oracledb.OBJECT
        }

        let retorno = await connection.execute(`SELECT ncodiusua codigo,
                                                       cnomeusua nome,
                                                       clogiusua login,
                                                       csudmusua password,
                                                       cadmiusua isadmin
                                                FROM CFGUSUA
                                                WHERE lower(clogiusua) = lower(:LOGIN)
                                                  and csudmusua = :password
                                                  AND csituusua = 'A'`,
            [usuario.login, this.decript(usuario.password)], options)

        if (retorno.rows.length === 0) {
            return
        }

        usuarioLogado.schema = this._database_config.schema.toString().toLowerCase()
        usuarioLogado.codigo = retorno.rows[0].CODIGO
        usuarioLogado.nome = retorno.rows[0].NOME
        usuarioLogado.login = retorno.rows[0].LOGIN
        usuarioLogado.password = `*********`
        usuarioLogado.departamento = usuario.departamento
        usuarioLogado.sucursal = usuario.sucursal

        return usuarioLogado
    }
}

module.exports = usuarioRepository